package Atlas::Utility::ObjectAttribute;

$VERSION=1.0;
use strict;

# Define both accessor and mutator methods for the attribute of the caller object
sub declare_rw {
    my($package)=caller; # the package name of the object call the method
    my($attrib, $qattrib);
    #
    foreach $attrib (@_) {
	$qattrib="'$attrib'"; # quoted attrib

	#use eval generate function for each attribute
	# the code will look like:
	#    sub $package::$attrib(intrepolated) {
	#           my($self)=shift; 
	#           my($val)=shift; 
	#           if (defined($val)) { $self->{$qattrib(intrepolated)}=$val; } #mutator
	#           $self->{$qattrib}; #accessor
        #    }
   
	eval 'sub '.$package.'::'.$attrib.' { 
    my($self)=shift; 
    my($val)=shift; 


    if (defined($val)) { $self->{'.$qattrib.'}=$val; }
    $self->{'.$qattrib.'}; 
}';

    }
}

# Define the accessor methods, a read only attribute
sub declare_ro {
    my($package)=caller(0);
    my($attrib, $qattrib);

    foreach $attrib (@_) {
	$qattrib="'$attrib'"; # quoted attrib

	# eval generate accessor function
	eval 'sub '.$package.'::'.$attrib.' {
   my($s)=shift; 
   $s->{'.$qattrib.'}; 
}';

    }
}

1;

__END__

=head1 NAME
Atlas::Utility::ObjectAttribute - a collection of helper functions for objects

=head1 VERSION
1.0

=MODIFICATION
APRIL 15, 2001

=head1 SYNOPSIS

use Atlas::Utility::ObjectAttribute;

Atlas::Utility::ObjectAttribute->declare_rw(@attributes);

Atlas::Utility::ObjectAttribute->declare_ro(@attributes);

=head1 DESCRIPTION

These functions need to be called inside the object class to generate
class functions.  It is NOT called by individual object.

=head2 Functions

Atlas::Utility::ObjectAttribute->declare_rw(@attributes);  <read and write 
functions generated for all elements in the array with the same name of the
attribute> 

Atlas::Utility::ObjectAttribute->declare_ro(@attributes); <read only
functions generated for all elements in the array with the same name of the
attribute> 

=head1 ENVIRONMENT

UNIX

=head1 FILES

Other Modules used:

NONE

=head1 LOCATION



=head1 AUTHOR

rui chen

ruichen@bcm.tmc.edu

==cut
